package at.bestsolution.rsd.rt.jpa;

import java.io.InputStream;
import java.net.URL;

import javax.persistence.EntityManager;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

@Deprecated
public class NamedQueriesLoader {
	@Deprecated
	public static void initializedNamedQueries(EntityManager entityManager, URL namedQueries) {
		initializedNamedQueries(Thread.currentThread().getContextClassLoader(), entityManager, namedQueries);
	}
	
	public static void initializedNamedQueries(ClassLoader classloader, EntityManager entityManager, URL namedQueries) {
		if( namedQueries != null ) {
			DocumentBuilderFactory f = DocumentBuilderFactory.newInstance();
			try {
				DocumentBuilder builder = f.newDocumentBuilder();
				try( InputStream in = namedQueries.openStream() ) {
					Document document = builder.parse(in);
					Element mappingElement = document.getDocumentElement();
					NodeList list = mappingElement.getElementsByTagName("named-query");
					for( int i = 0; i < list.getLength(); i++ ) {
						Element namedQuery = (Element) list.item(i);
						Element query = (Element) namedQuery.getElementsByTagName("query").item(0);
						Text queryText = (Text) query.getFirstChild();
						entityManager.getEntityManagerFactory().addNamedQuery(namedQuery.getAttribute("name"), entityManager.createQuery(queryText.getData().trim()));
					}
					list = mappingElement.getElementsByTagName("named-native-query");
					for( int i = 0; i < list.getLength(); i++ ) {
						Element namedQuery = (Element) list.item(i);
						Element query = (Element) namedQuery.getElementsByTagName("query").item(0);
						Text queryText = (Text) query.getFirstChild();
						entityManager.getEntityManagerFactory().addNamedQuery(namedQuery.getAttribute("name"), 
								entityManager.createNativeQuery(queryText.getData().trim(), Class.forName(namedQuery.getAttribute("result-class"), true, classloader))
						);
					}
				}
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
}